//  Put your file header here

import java.io.*;

// Put your class header here
public class A2 {

    // Put a method header here
    public static void main ( String [] args ) throws IOException {

        // example of getting user input
        String filename = getString( "Enter the name of a file: " );

        // example of getting an integer from the user
        int number = getInteger( "Enter any valid integer: " );

        // example of producing user output
        System.out.println( "You entered filename = " + filename  
            + " and integer = " + number );

    }

    ////////////////////////////////////////////////////////////
    // Some private class members to assist you with user input
    ////////////////////////////////////////////////////////////

    /** Included to allow for user input. */
    private static BufferedReader stdin = new BufferedReader(
        new InputStreamReader( System.in ) );

    /** 
     *  Returns the string of characters entered by the user
     *  in response to being shown the prompt.  This method 
     *  catches IOExceptions and returns null in that case.
     *
     *  @param prompt The input prompt to show the user.
     *  @return The string of characters entered on the keyboard
     *  by the user.  Stops at the new line [Enter].
     */
    private static String getString( String prompt ) {
        try {
            System.out.print( prompt );
            return stdin.readLine();
        }
        catch ( IOException e ) {
            System.out.println("Ignoring an IOException while reading a line of user input");
        }
        return null;
    }

    /** 
     *  Returns an integer value as entered by the user
     *  in response to being shown the prompt.  This method 
     *  catches NumberFormatExceptions and reprompts the user
     *  until a valid integer is input.
     *
     *  @param prompt The input prompt to show the user.
     *  @return The string of characters entered on the keyboard
     *  by the user.  Stops at the new line [Enter].
     */
    private static int getInteger( String prompt ) {
        while ( true ) {
            try { return Integer.parseInt( getString (prompt) ); }
            catch ( NumberFormatException e ) {
                System.out.println("Sorry, that is not a valid integer.");
            }
        }
        //return -1;
    }

}
