///////////////////////////////////////////////////////////////////////////////
// File:       A2.java
//
// Assignment: Assignment 2: Hashing and Sorting
// Course:     CS367, Spring 2004
// Date:       3/3/04
//
// Student:    Justin Fiedler
// Lecture:    
// CS Login:   fiedler
///////////////////////////////////////////////////////////////////////////////

import java.io.*;

/**
 * A class that allows a user to create a SymbolTable to store the number of
 * occurances of specific Symbols in selected files.  A file containing 
 * reserved Symbols must be read to indicate which words should be recognized
 * as reserved.
 *
 * <p>Bugs: None
 *
 * @author Justin Fiedler
 */
public class A2 
{	private SymbolTable st;
	
	public A2() throws IOException
	{	int choice;
		int tableSize;
		boolean sourceRead = false;
		String filename = "";
		
		//read in the size of the hash table
		do
		{	tableSize = getInteger("Enter the initial size of the hash table: ");
			if(tableSize < 1)
			{	System.out.println("The hash table must have at least size 1");
			}
		}while(tableSize < 1);
		
		st = new SymbolTable(tableSize);
		
		//read in the file of reserved words
		do
		{	try
			{	filename = getString("Enter the name of the reserved word file: ");
				st.read(filename, true);
			}
			catch(IOException e)
			{	filename = "";
			}
		}while(filename == "");
		
		String menuString = "Source Code Analyzer\n" +
       						"-----------------------------------------\n" + 
       						"1.  Read a source file into the Symbol Table.\n" +
       						"2.  Look up a symbol.\n" +
       						"3.  Display all symbols in their hash order.\n" +
       						"4.  Display source symbols in sorted order.\n" +
       						"5.  Exit\n" +
							"Enter choice: ";
		
		do
		{	choice = getInteger(menuString);
			switch(choice)
			{	case 1://read a file
					do
					{	try
						{	filename = getString("Enter the name of the source file: ");
							st.read(filename, false);
						}
						catch(IOException e)
						{	filename = "";
						}
					}while(filename == "");
					sourceRead = true;
					break;
					
				case 2://lookup symbol
					String sym = getString("Which symbol do you want to display? ");
					System.out.println(st.find(sym));
					break;
					
				case 3://display in hash order
					System.out.println(st);
					break;
				case 4://display sorted
					if(sourceRead)
					{	System.out.println(st.toSortedString());
					}
					else
					{	System.out.println("No source file has been selected");
					}
					break;
				case 5://exit
					break;
				default:
					System.out.println("Please enter a choice 1-5");
					break;
			}
		}while(choice != 5);	
	}
	
    // create a new A2
    public static void main ( String [] args ) throws IOException
    {  	new A2();
    }

    ////////////////////////////////////////////////////////////
    // Some private class members to assist you with user input
    ////////////////////////////////////////////////////////////

    /** Included to allow for user input. */
    private static BufferedReader stdin = new BufferedReader(
        new InputStreamReader( System.in ) );

    /** 
     *  Returns the string of characters entered by the user
     *  in response to being shown the prompt.  This method 
     *  catches IOExceptions and returns null in that case.
     *
     *  @param prompt The input prompt to show the user.
     *  @return The string of characters entered on the keyboard
     *  by the user.  Stops at the new line [Enter].
     */
    private static String getString( String prompt ) {
        try {
            System.out.print( prompt );
            return stdin.readLine();
        }
        catch ( IOException e ) {
            System.out.println("Ignoring an IOException while reading a line of user input");
        }
        return null;
    }

    /** 
     *  Returns an integer value as entered by the user
     *  in response to being shown the prompt.  This method 
     *  catches NumberFormatExceptions and reprompts the user
     *  until a valid integer is input.
     *
     *  @param prompt The input prompt to show the user.
     *  @return The string of characters entered on the keyboard
     *  by the user.  Stops at the new line [Enter].
     */
    private static int getInteger( String prompt ) {
        while ( true ) {
            try { return Integer.parseInt( getString (prompt) ); }
            catch ( NumberFormatException e ) {
                System.out.println("Sorry, that is not a valid integer.");
            }
        }
        //return -1;
    }

}
