///////////////////////////////////////////////////////////////////////////////
// File:       Symbol.java
//
// Assignment: Assignment 2: Hashing and Sorting
// Course:     CS367, Spring 2004
// Date:       3/3/04
//
// Student:    Justin Fiedler
// Lecture:    
// CS Login:   fiedler
///////////////////////////////////////////////////////////////////////////////

/**
 * The Symbol class is a structure to store imformation about symbols
 * including the string representation of the symbol and whether it is
 * a reserved word or not and the count.
 *
 * <p>Bugs: N0n3x0r
 *
 * @author Justin Fiedler
 */
public class Symbol
{	private String s;
	private char reserved;
	private int i;
	
	/**         
     * Constructs a new Symbol object
     *
     * @param s the name of the symbol
     * @param reserved whether or not the symbol is a reserve word
     * @param i the number of times this symbol occurs
     */
	public Symbol(String s, boolean reserved, int i)
	{	this.s = s;
		if(reserved)
		{	this.reserved = 'R';
		}
		else
		{	this.reserved = 'N';
		}
		this.i = i;
	}
	
	/**         
     * Gets the name of the Symbol
     *
     * @return a String object containing the name of the Symbol
     */
	public String getString()
	{	return s;
	}
	
	/**         
     * Gets the count of the Symbol
     *
     * @return the count of the Symbol
     */
	public int getCount()
	{	return i;
	}
	
	/**         
     * Adds 1 to the count of the Symbol
     */
	public void increment()
	{	i++;
	}
	
	/**         
     * Returns the Symbol object as a String
     *
     * @return a String representing the Symbol
     */
	public String toString()
	{	return s + ':' + reserved + ' ' + i;
	}	
}